<script setup>
defineProps({
	label: {
		type: String,
		required: true,
		default: "",
	},
	textarea: {
		type: Boolean,
		default: false,
	},
	placeholder: {
		type: String,
		required: true,
		default: "",
	},
	error: {
		type: [String, Array],
		default: "",
	},
	modelValue: {
		type: [String, Number],
		default: "",
	},
});

const emit = defineEmits(["update:modelValue"]);
function onChange(e) {
	emit("update:modelValue", e.target.value);
}
</script>

<template>
	<div class="wrapper">
		<div class="fs8">{{ label }} :</div>
		<div class="input flex-center">
			<slot name="prepend"></slot>
			<textarea
				v-if="textarea"
				class="fs"
				:placeholder="placeholder"
				:value="modelValue"
				@input="onChange"
				cols="30"
				rows="10"
			></textarea>
			<input
				v-else
				type="text"
				class="fs"
				:placeholder="placeholder"
				:value="modelValue"
				@input="onChange"
			/>
			<slot name="append"></slot>
		</div>
		<div v-if="error" class="error fs7">
			{{ Array.isArray(error) ? error[0] : error }}
		</div>
	</div>
</template>

<style lang="scss" scoped>
.wrapper {
	margin-top: 10px;

	.error {
		color: rgb(160, 27, 27);
	}
}
.input {
	box-sizing: border-box;
	display: flex;
	margin-top: 5px;
	border: 2px solid #ccc;
	border-radius: 5px;
	overflow: hidden;

	input {
		outline: unset;
		min-width: 250px;
		border: 0px;
		height: 40px;
		flex: 1;
		padding: 0px 10px;
	}
	textarea {
		outline: unset;
		min-width: 250px;
		border: 0px;
		flex: 1;
		padding: 7px 10px;
	}
}
</style>
